
# saft.pl --- brings SAFT into X-Chat

# $Id: saft.pl,v 1.6 1999/08/16 20:31:18 stesch Exp stesch $

# See <URL:ftp://ftp.uni-stuttgart.de/pub/unix/comm/sendfile/> for
# a current version of sendfile

# 1999-08-16	Convert old sirc-code for X-Chat
#		Stefan Scholl <stesch@parsec.rhein-neckar.de>

# 1998-05-24    Comments in the source. Lazy guy ...
#               Stefan Scholl <stesch@parsec.rhein-neckar.de>
#
# 1998-05-22    Now with "***" before sendfile-output
#               Stefan Scholl <stesch@parsec.rhein-neckar.de>
#
# 1998-05-21    1st Version
#               Stefan Scholl <stesch@parsec.rhein-neckar.de>
#

# ####################################################################


# === Register the script i===========================================

IRC::register ("saft", "1.6", "", "");

# ====================================================================


# === Subroutines ====================================================

# --- Main sub for sending a file. -----------------------------------
sub saftit {
	my ($dest, $object) = @_;
    	my $opt = "-q ";
    	my $x;
    	my $fh;
    
    	if(-d $object) {    # Is it a directory? Then we need an archive name
        	$x = $object;
        	$x =~ s/[\.\/]/_/g;  # no "." or "/" in archive name
        
        	$opt .= "-a=$x ";
    	} 
    
    	$opt .= "$object $dest";

	IRC::command("/exec sendfile $opt");
}


# --- The saft help ---------------------------------------------------

sub help_saft {
	IRC::print <<'SAFTHELP';
Usage: /SAFT <nick>|<saft-url> <file>|<directory>

saft-url = username@host or saft://host/username
SAFTHELP
}


# --- Handler to simulate sirc's &userhost() --------------------------
#         302     RPL_USERHOST
#                        ":[<reply>{<space><reply>}]"
#
#                 <reply> ::= <nick>['*'] '=' <'+'|'-'><hostname>
#
# :parsec.rhein-neckar.de 302 stesch :stesch=+stesch@parsec.rhein-neckar.de
#
sub userhost_handler {
	my $nick;
	my $user;
	my $host;

	($nick, $user, $host) =
		($_[0] =~ /302.*?:(.*?)=.(.*?)@(.*)/);
	
	$nick =~ s/\*$//; # get rid of trailing '*'

	
	foreach $k (keys %uh) {
		my $snick;
		my $evalstring;

		($snick, $evalstring) = split(/:/, $k, 2);

		if(lc($snick) eq lc($nick)) {
			eval $evalstring;
			delete $uh{$k};
		}
	}
	return 1;
}

# --- sirc's &userhost(); kind of -------------------------------------

sub userhost {
	my $nick = shift;
	my $evalstring = shift;

	$uh{"$nick:$evalstring"} = 42;
	IRC::command("/userhost $nick");
}

# --- The saft command ------------------------------------------------
sub cmd_saft {
    	my $dest;
    	my $object;
    
	
	($dest, $object) = split(/\s+/, $_[0]);
    	unless(defined($object)) {
		help_saft();
        	return 1;
    	}
    
    	if(($dest =~ /\@/) or ($dest =~ /^saft:\/\//)) {  # valid saft-address
        	saftit($dest, $object);
    	} else {	    	    	    # Or find saft-address via nickname
        	userhost($dest, "&saftit(\$user . '\@' . \$host, '$object');");
    	}

	return 1;
}

# =====================================================================


# === MAIN ============================================================

IRC::add_command_handler('saft', 'cmd_saft');
IRC::add_message_handler('302', 'userhost_handler'); # RPL_USERHOST
IRC::print "saft loaded\n";
help_saft();

# =====================================================================
